events.listen('recipes', event => {

  event.shaped(item.of('rangedpumps:pump', 1), [
    'OTO',
    'LMW',
    'OPO'
  ], {
    O: '#forge:obsidian',
    T: 'mekanism:basic_fluid_tank',
    L: 'minecraft:lava_bucket',
    M: '#forge:machineframe/basic',
    W: 'minecraft:water_bucket',
    P: 'mekanism:basic_mechanical_pipe'
  })

  event.shaped(item.of('globalxp:xp_block', 1), [
    'ABA',
    'ACA',
    'ADA'
  ], {
    A: 'minecraft:iron_bars',
    B: 'engineerstools:charged_lapis_squeezer',
    C: 'mekanism:pellet_antimatter',
    D: 'darkutils:ender_hopper'
  })

  event.shaped(item.of('angelring:itemdiamondring', 1), [
    'NGN',
    'BEB',
    'NGN'
  ], {
    E: 'minecraft:elytra',
    B: '#forge:storage_blocks/diamond',
    N: '#forge:ingots/netherite',
    G: 'minecraft:nether_star'
  })

  event.shaped(item.of('angelring:itemring', 1), [
    'FBF',
    'BRB',
    'PBP'
  ], {
    F: '#forge:feathers',
    B: '#forge:storage_blocks/gold',
    R: 'angelring:itemdiamondring',
    P: 'simplyjetpacks:thruster_mek4'
  })


  event.shaped(item.of('engineerstools:material_box', 1), [
    'AAA',
    'BCB',
    'BBB'
  ], {
    A: 'minecraft:string',
    B: '#forge:ingots/iron',
    C: 'ironchest:iron_chest'
  })

  event.shaped(item.of('pneumaticcraft:compressed_iron_gear', 1), [
    ' A ',
    'ABA',
    ' A '
  ], {
    A: '#forge:ingots/compressed_iron',
    B: '#forge:ingots/iron'
  })

  event.shaped(item.of('xnet:controller', 1), [
    'EFE',
    'CDC',
    'EAE'
  ], {
    A: '#forge:ingots/gold',
    C: '#forge:dusts/redstone',
    D: 'rftoolsbase:machine_frame',
    E: '#forge:ingots/iron',
    F: 'computercraft:computer_advanced'
  })

  event.shaped(item.of('torchmaster:megatorch', 1), [
    'ABC',
    'DED',
    'FEF'
  ], {
    A: item.of('minecraft:potion', {Potion:"minecraft:strong_regeneration"}),
    B: 'minecraft:soul_campfire',
    C: item.of('minecraft:potion', {Potion:"minecraft:strong_healing"}),
    D: '#forge:gems/diamond',
    E: 'minecraft:hay_block',
    F: '#forge:storage_blocks/gold'
  })

  event.shaped(item.of('torchmaster:feral_flare_lantern', 1), [
    ' A ',
    'BCB',
    ' A '
  ], {
    A: '#forge:ingots/gold',
    B: 'minecraft:lantern',
    C: '#forge:dusts/glowstone'
  })

  event.shaped(item.of('minecraft:soul_campfire', 1), [
    ' A ',
    'ABA',
    'CCC'
  ], {
    A: '#forge:rods/blaze',
    B: '#minecraft:soul_fire_base_blocks',
    C: '#minecraft:logs'
  })

  event.shaped(item.of('javd:portal_block', 1), [
    'ADA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:end_stone_bricks',
    B: 'torchmaster:megatorch',
    C: 'minecraft:end_crystal',
    D: 'minecraft:ender_pearl'
  })

  event.shaped(item.of('jamd:mine_portal_block', 1), [
    'ADA',
    'BCB',
    'ABA'
  ], {
    A: 'minecraft:end_stone_bricks',
    B: 'torchmaster:megatorch',
    C: 'minecraft:diamond_pickaxe',
    D: 'minecraft:ender_pearl'
  })

  event.shaped(item.of('pamhc2foodcore:rolleritem', 1), [
    '  A',
    ' B ',
    'A  '
  ], {
    A: '#forge:rods/wooden',
    B: '#minecraft:logs'
  })

  event.shaped(item.of('quark:backpack', 1), [
    'AAA',
    'ABA',
    'ACA'
  ], {
    A: 'minecraft:leather',
    B: '#forge:chests/wooden',
    C: '#forge:ingots/iron'
  })

  event.shaped(('1x ae2wtlib:infinity_booster_card'), [
    'BCB',
    'BQB',
    'BAB'
  ], {
    A: 'appliedenergistics2:advanced_card',
    B: 'appliedenergistics2:quantum_ring',
    C: 'lazierae2:parallel_processor',
    Q: 'appliedenergistics2:singularity'
  })

  event.shapeless(item.of('minecraft:chest', 1), ['#forge:chests/wooden'])
  event.shapeless(item.of('immersiveengineering:storage_uranium', 2), ['mekanism:block_uranium', 'mekanism:block_uranium'])
  event.shapeless(item.of('quark:marble', 1), ['astralsorcery:marble_raw'])
  event.shapeless(item.of('astralsorcery:marble_raw', 1), ['quark:marble'])
  event.shapeless(item.of('quark:limestone', 1), ['create:limestone'])
  event.shapeless(item.of('create:limestone', 1), ['quark:limestone'])
  event.shapeless(('1x thermal:lead_ingot'), ['1x eidolon:lead_ingot'])
  event.shapeless(('6x eidolon:lead_ingot'), ['6x thermal:lead_ingot'])


  const multiSmelt = (output, input) => {
    event.smelting(output, input)
    event.blasting(output, input)
  }

  multiSmelt('eidolon:enchanted_ash', 'minecraft:bone_meal')
})
